%define version_maj 2
%define version_min 0
%define version_rev 1
%define version_tag SP2_CP04
%define version_full %{version_maj}.%{version_min}.%{version_rev}.%{version_tag}.patch01

%define _with_repolib 1

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/jboss/jbossws/%{version_full}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define native_repodir %{_javadir}/repository.jboss.com/jboss/jbossws-native42/%{version_full}-brew
%define native_repodirlib %{native_repodir}/lib
%define native_repodirsrc %{native_repodir}/src

 
Summary:        JBoss Web Services
Name:           jbossws
Version:        %{version_maj}.%{version_min}.%{version_rev}
Release:        3.%{version_tag}.4.1.ep1%{?dist}
Epoch:          0
License:        LGPL
Group:          Development/Java
URL:            http://labs.jboss.com/jbossws/

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildArch:      noarch

# svn export http://anonsvn.jboss.org/repos/jbossws/stack/native/tags/jbossws-native-2.0.1.SP2_CP04 jbossws 
# Note: Exported external at revision 9755.
# tar czf jbossws-2.0.1.SP2_CP04-src.tar.gz jbossws
Source0:        %{name}-%{version}.%{version_tag}-src.tar.gz
Source1:        %{name}-component-info.xml
Source2:        jbossws-native42-component-info.xml
# FIXME: We should have a build of jbossws-jboss42 2.0.1 so we could grab 
# this resources from there.
# wget http://repository.jboss.com/jboss/jbossws-jboss42/2.0.1.GA_CP01/lib/jbossws-jboss42-resources.zip
Source3:        %{name}-jboss42-resources.zip
#kept the old name - jbossws-2.0.1.SP2_CP02-tp.tar.gz since that's where we got the tar ball from
#Source4:        %{name}-%{version}.%{version_tag}-tp.tar.gz
Source4:        %{name}-%{version}.SP2_CP02-tp.tar.gz
#JBPAPP-1798
Patch0:         %{name}-CVE-2009-0027.patch

BuildRequires: ant
BuildRequires: bea-stax-api
BuildRequires: glassfish-jaf
BuildRequires: glassfish-jaxb
BuildRequires: glassfish-jaxws
BuildRequires: dom4j
BuildRequires: glassfish-javamail
BuildRequires: gnu-getopt
BuildRequires: javassist
BuildRequires: jbossas >= 4.3.0
BuildRequires: jboss-common
BuildRequires: jboss-remoting
BuildRequires: jbossws-common
BuildRequires: jbossws-framework
BuildRequires: jbossws-spi
BuildRequires: jbossxb
BuildRequires: jpackage-utils
BuildRequires: tomcat5-servlet-2.4-api
BuildRequires: wsdl4j16
BuildRequires: wstx
BuildRequires: ws-commons-policy
BuildRequires: xalan-j2
BuildRequires: xerces-j2
BuildRequires: xml-security

Requires:      bea-stax-api
Requires:      glassfish-jaf
Requires: glassfish-jaxb
Requires: glassfish-jaxws
Requires:      dom4j
Requires:      glassfish-javamail
Requires:      gnu-getopt
Requires:      javassist
Requires:      jbossas >= 4.3.0
Requires:      jboss-common
Requires:      jboss-remoting
Requires:      jbossws-common
Requires:      jbossws-framework
Requires:      jbossws-spi
Requires:      jbossxb
Requires:      jpackage-utils
Requires:      tomcat5-servlet-2.4-api
Requires:      wsdl4j16
Requires:      wstx

# Commons policy is not distributed as rpm for now
#Requires:      ws-commons-policy

Requires:      xalan-j2
Requires:      xerces-j2
Requires:      xml-security

%description
JBossWS an implementation of J2EE Web Services

%package     native42
Summary:     native42 component for jbossws
Group:       Development/Java

%description native42
native42 component for jbossws

%if %{with_repolib}
%package     repolib
Summary:     Artifacts to be uploaded to a repository library
Group:  Development/Libraries/Java

%description     repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio

%package     native42-repolib
Summary:     Artifacts to be uploaded to a repository library
Group:  Development/Libraries/Java

%description     native42-repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%prep
%setup -q -n %{name} 

# Extract thirdparty
tar xzf %{SOURCE4}

sed -i 's/@VERSION@/%{version}.%{version_tag}-brew/g' %{SOURCE1}
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE1}

# native42
sed -i 's/@VERSION@/%{version}.%{version_tag}-brew/g' %{SOURCE2}
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE2}

%patch0 -p0

%build

export JBOSS_HOME=%{_datadir}/jbossas
mkdir thirdparty/

pushd thirdparty/
# Link available system jars
ln -s $(build-classpath activation) .
ln -s $(build-classpath ant) .
ln -s $(build-classpath dom4j) .
ln -s $(build-classpath gnu-getopt) getopt.jar
ln -s $(build-classpath javassist) .
ln -s $(build-classpath jboss-common/jboss-common) jboss-common-core.jar
ln -s $(build-classpath jbossas/jboss-j2ee) .
ln -s $(build-classpath jboss-common/jboss-common) jboss-logging-spi.jar
ln -s $(build-classpath jboss-remoting) .
ln -s $(build-classpath jboss/jboss-xml-binding) .
ln -s $(build-classpath jbossas/jbosssx) .
ln -s $(build-classpath jbossws-common) .
ln -s $(build-classpath jbossws-framework) .
ln -s $(build-classpath jbossws-spi) .
ln -s $(build-classpath sun-jaxb/jaxb-api.jar) .
ln -s $(build-classpath sun-jaxb/jaxb-impl.jar) .
ln -s $(build-classpath sun-jaxb/jaxb-xjc.jar) .
ln -s $(build-classpath sun-jaxws/jaxws-tools.jar) .
ln -s $(build-classpath glassfish-javamail-monolithic) mail.jar
ln -s $(build-classpath ws-commons-policy.jar) policy.jar
ln -s $(build-classpath tomcat5-servlet-2.4-api) servlet-api.jar
ln -s $(build-classpath bea-stax-api) stax-api.jar
ln -s $(build-classpath wsdl4j/wsdl4j16) wsdl4j.jar
ln -s $(build-classpath wstx/wstx-asl) wstx.jar
ln -s $(build-classpath xalan-j2) xalan.jar
ln -s $(build-classpath xalan-j2-serializer) .
ln -s $(build-classpath xmlsec) .
ln -s $(build-classpath xerces-j2) xercesImpl.jar
cp -a $JBOSS_HOME/server/all/deploy/ejb3.deployer .
ln -s $(build-classpath jbossas/jboss-ejb3x) ejb3.deployer/

# Copy pre-built files from tp
cp ../thirdpartyrepo/jboss/microcontainer/lib/jboss-dependency.jar .
cp ../thirdpartyrepo/jboss/microcontainer/lib/jboss-microcontainer.jar .
cp ../thirdpartyrepo/jboss/jaxbintros/1.0.0.beta2/lib/jboss-jaxb-intros.jar .

# Copy resources
cp %{SOURCE3} jbossws-jboss42-resources.zip
popd

mv ant.properties.example ant.properties

# Build jbossws
ant -Djboss42.home=$JBOSS_HOME -Djboss.server.instance=all -Dchecksum.ok=true jars

%install
rm -rf $RPM_BUILD_ROOT

# Install to javadir
install -dm 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/native42/sar
unzip -q -d $RPM_BUILD_ROOT%{_javadir}/%{name}/native42/sar output/lib/%{name}-native42.sar
cp -p output/lib/jboss-jaxrpc.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
cp -p output/lib/jboss-jaxws.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
cp -p output/lib/jboss-saaj.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
cp -p output/lib/jbossws-client.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
cp -p output/lib/jbossws-core.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
cp -p output/lib/jbossws-core-scripts.zip $RPM_BUILD_ROOT%{_javadir}/%{name}
cp -p output/lib/jbossws-core-src.zip $RPM_BUILD_ROOT%{_javadir}/%{name}

# -repolib
%if %{with_repolib}

    # jboss/jbossws
    install -d -m 755 $RPM_BUILD_ROOT%{repodir}
    install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
    install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodir}/component-info.xml

    install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
    install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}/jbossws-%{version_full}-src.tar.gz
    install -m 755 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}/

    cp -p output/lib/jboss-jaxrpc.jar $RPM_BUILD_ROOT%{repodirlib}
    cp -p output/lib/jboss-jaxws.jar $RPM_BUILD_ROOT%{repodirlib}
    cp -p output/lib/jboss-saaj.jar $RPM_BUILD_ROOT%{repodirlib}
    cp -p output/lib/jbossws-client.jar $RPM_BUILD_ROOT%{repodirlib}
    cp -p output/lib/jbossws-core.jar $RPM_BUILD_ROOT%{repodirlib}
    cp -p output/lib/jbossws-core-scripts.zip $RPM_BUILD_ROOT%{repodirlib}
    cp -p output/lib/jbossws-core-src.zip $RPM_BUILD_ROOT%{repodirlib}

    # jboss/jbossws-native42
    install -d -m 755 $RPM_BUILD_ROOT%{native_repodir}
    install -d -m 755 $RPM_BUILD_ROOT%{native_repodirlib}
    install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{native_repodir}/component-info.xml

    install -d -m 755 $RPM_BUILD_ROOT%{native_repodirsrc}
    install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{native_repodirsrc}/jbossws-native42-%{version_full}-src.tar.gz

    cp -p output/lib/%{name}-native42.sar $RPM_BUILD_ROOT%{native_repodirlib}

%endif


%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*jar
%{_javadir}/%{name}/*zip

%files native42
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/native42

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}

%files native42-repolib
%defattr(0644,root,root,0755)
%{native_repodir}
%endif


%changelog
* Mon Apr 06 2009 Permaine Cheung <pcheung@redhat.com> 2.0.1-3.SP2_CP04.4.1
- Build from jbossws-native-2.0.1.SP2_CP04 branch and apply the patch
  for CVE-2009-0027

* Thu Mar 26 2009 Permaine Cheung <pcheung@redhat.com> 2.0.1-3.SP2_CP04.3.1
- Build SP2_CP04_JBPAPP-1798 for CC

* Tue Feb 10 2009 Permaine Cheung <pcheung@redhat.com> 2.0.1-3.SP2_CP05.3.1
- Merge with RHEL 4

* Wed Feb 04 2009 Permaine Cheung <pcheung@redhat.com> 2.0.1-3.SP2_CP05.3
- Keep only the 2.1.4.patch01-brew compatible line for sun-jaxb

* Wed Feb 04 2009 Permaine Cheung <pcheung@redhat.com> 2.0.1-3.SP2_CP05.2
- Add compatible line for sun-jaxb

* Fri Jan 16 2009 Permaine Cheung <pcheung@redhat.com> 2.0.1-3.SP2_CP05.1
- Update to SP2_CP05
- Update component-info.xml

* Wed Jan 07 2009 Permaine Cheung <pcheung@redhat.com> 2.0.1-3.SP2_CP04.2
- Add compatible line for Remoting 2.2.2.SP11-brew

* Wed Oct 08 2008 Fernando Nasser <fnasser@redhat.com> 2.0.1-3.SP2_CP04.1.1
- Update to SP2_CP04

* Tue Aug 05 2008 Fernando Nasser <fnasser@redhat.com> 2.0.1-2.SP2_CP03.0jpp.ep1.1.1
- Merge for CP03 upgrade

* Tue Aug 05 2008 Fernando Nasser <fnasser@redhat.com> 2.0.1-2.SP2_CP02.0jpp.ep1.5.1
- Use wsdl4j16 on RHEL-5

* Fri Aug 01 2008 Permaine Cheung <pcheung@redhat.com> 2.0.1-2.SP2_CP03.0jpp.ep1.1
- Update to SP2_CP03

* Wed Jul 30 2008 Fernando Nasser <fnasser@redhat.com> 2.0.1-2.SP2_CP02.0jpp.ep1.5
- Add compatible line for Remoting 2.2.2.SP9-brew for jbossws-native42

* Thu Jul 24 2008 Fernando Nasser <fnasser@redhat.com> 2.0.1-2.SP2_CP02.0jpp.ep1.4
- Use glassfish-{jaxb,jaxws} packages
- Use latest jaxbintros not the one in the previous jbossas

* Thu Jul 17 2008 Clive Saldanha <csaldanh@redhat.com> 2.0.1-2.SP2_CP02.0jpp.ep1.3
- Change component-info to refer -brew versions of sun-jaxb and sun-jaxws

* Mon Jul 07 2008 Deepak Bhole <dbhole@redhat.com> 2.0.1-2.SP2_CP01.0jpp.ep1.3
- Temporary fix for JBPAPP-941
- Fix dir ownership

* Fri Jun 27 2008 David Walluck <dwalluck@redhat.com> 0:2.0.1-2.SP2_CP02.0jpp.ep1.1
- SP2_CP02

* Tue Jun 24 2008 David Walluck <dwalluck@redhat.com> 0:2.0.1-2.SP2_CP01.0jpp.ep1.3
- update Remoting 2.2.2.SP8 as compatible
- own %%{_javadir}/%%{name}

* Wed Apr 02 2008 Deepak Bhole <dbhole@redhat.com> 0:2.0.1-2.SP2_CP01.0jpp.ep1.2
- Update compatible versions in jbossws-native42 for jbossws and remoting

* Fri Mar 28 2008 Deepak Bhole <dbhole@redhat.com> 0:2.0.1-2.SP2_CP01.0jpp.ep1.1
- Update to SP2_CP01

* Tue Mar 18 2008 Deepak Bhole <dbhole@redhat.com> 0:2.0.1-1.SP2.0jpp.ep1.5
- Initial build
